"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _nodeFetch = _interopRequireDefault(require("node-fetch"));

var _moduleReplication = require("@resolve-js/module-replication");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore
const callReplicate = async (pool, events, secretsToSet, secretsToDelete, iterator) => {
  const data = {
    events,
    secretsToSet,
    secretsToDelete,
    iterator
  };
  const response = await (0, _nodeFetch.default)(`${pool.targetApplicationUrl}${_moduleReplication.REPLICATE.endpoint}`, {
    method: _moduleReplication.REPLICATE.method,
    body: JSON.stringify(data),
    headers: {
      'Content-Type': 'application/json'
    }
  });
  let resultType = 'unknown';
  const message = await response.text();

  if (response.status >= 500) {
    resultType = 'serverError';
  } else if (response.status >= 400) {
    resultType = 'clientError';
  } else if (response.status === 202 || response.status === 200) {
    resultType = 'launched';
  }

  return {
    type: resultType,
    httpStatus: response.status,
    message: message
  };
};

var _default = callReplicate;
exports.default = _default;
//# sourceMappingURL=call-replicate.js.map